/*
 *    video.h - generic utility for MZ-800
 *
 *    Copyright (c) 2012 by Michal Hucik <http://www.ordoz.com>
 *
 *    Thies program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    driver_FDC is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with driver_FDC; if not, write to the Free Software
 *    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef _MZ800_video
#define _MZ800_video

/* funkce pro rychle smazani viditelne VRAM */
extern void video_cls ( void );

/* cekani na zacatek zatemneni */
extern void video_wait_to_blnk ( void );

/* pozice kurzoru pro prnc a msg */
extern struct curpos_s {
    char pos_x;
    char pos_y;
} cur;

/* adresa instrukce inverzniho tisku */
extern unsigned char fl_INVPRN;

extern void prnc ( char c );

extern void msg ( const char *c );

#define MZ800_INVPRNon() { fl_INVPRN = 0x2f; }  // instrukce CPL

#define MZ800_INVPRNoff() { fl_INVPRN = 0x00; }
        

/* Registr barvy borderu */
__sfr __banked __at		0x06cf	rBCOLOR;

/* Registr palet */
__sfr __at			0xf0	rPAL;

#define SET_PALGRP		( 1 << 6 )

#define PAL0			( 0 << 4 )
#define PAL1			( 1 << 4 )
#define PAL2			( 2 << 4 )
#define PAL3			( 3 << 4 )

/* Registry pro praci s VRAM */
__sfr __at 			0xcd 	rRF;

__sfr __at 			0xcc 	rWF;

#define RF_READ			( 0 << 7 )
#define RF_SEARCH		( 1 << 7 )

#define WF_SINGLE		( 0 << 5 )
#define WF_EXOR			( 1 << 5 )
#define WF_OR			( 2 << 5 )
#define WF_RESET		( 3 << 5 )
#define WF_REPLACE		( 4 << 5 )
#define WF_PSET			( 6 << 5 )

#define FRAME_A			( 0 << 4 )
#define FRAME_B			( 1 << 4 )

#define PLANE_I			( 1 << 0 )
#define PLANE_II		( 1 << 1 )
#define PLANE_III		( 1 << 2 )
#define PLANE_IV		( 1 << 3 )


/* Screen COLOR ( MZ800 ) */
typedef enum {
    BLACK = 0,
    BLUE,
    RED,
    MAGENTA,

    GREEN,
    CYAN,
    YELOW,
    WHITE,

    GREY,
    LBLUE,
    LRED,
    LMAGENTA,

    LGREEN,
    LCYAN,
    LYELOW,
    LWHITE,    
} COLOR;

#endif
